boolean AckOn=false; // enable the call back phone call as an ACK  (ACK OFF)
boolean Privacy=true;// printout of phone number masked at default (PRI ON)
char position;

void ReadSms(void)
{//Read if there are messages on SIM card and decode the commnand
      position = sms.IsSMSPresent(SMS_ALL);
      if (position) 
      {
        // read new SMS checking if the caller is authorized
        // if the number is into the SIM phone book this is a superuser and can perform
        // also administrative functions
        if (GETSMS_AUTH_SMS == sms.GetAuthorizedSMS(position, phone_number, TmpStr, 30, 1, 3))
        {
          Serial.println("");
          Serial.print("Superuser call: ");
          PrivacyPrint();
          Serial.print("  Msg: ");
          Serial.println(TmpStr);
          
          ToUpperTmpStr();
                    
          if(!SuperUserCmd()) // administrative actions
          {
            if(!UserCmd()) // and standard actions
            {// wrong command string
              Serial.println("Command not recognized");
            }
          }
        }
        else if(CheckGranted(phone_number)!=0xFF)
        {// just standard actions
          Serial.println("");
          Serial.print("Granted call: ");
          PrivacyPrint();
          Serial.print("  Msg: ");
          Serial.println(TmpStr);

          ToUpperTmpStr();
          
          if(!UserCmd())
          {// wrong command string
            Serial.println("Command not recognized");
          }
        }
        else
        {// the caller is not in SIM nor in EEPROM phone books
          Serial.print("NOT granted call: ");
          Serial.print(phone_number);
          Serial.print("  Msg: ");
          Serial.println(TmpStr);
        }

        // port status printout
        Serial.print("Out 1 = ");
        Serial.print(digitalRead(Out1));
        Serial.print(" - Out 2 = ");
        Serial.println(digitalRead(Out2));
        sms.DeleteSMS(position);  
      }
      delay(1000);
}

boolean SuperUserCmd(void)
 {// administrative actions
  
  if(!strcmp(TmpStr,"ACK ON"))
  {// Enable Acknowledge call back
    AckOn = true;
  }
  else if(!strcmp(TmpStr,"ACK OFF"))
  {// Disable Acknowledge call back
    AckOn = false;
  }
  else if(!strcmp(TmpStr,"PRI ON"))
  {// Enable privacy
    Privacy = true;
  }
  else if(!strcmp(TmpStr,"PRI OFF"))
  {// Disable privacy
    Privacy = false;
  }
  else if(!strcmp(TmpStr,"INFO"))
  {// Request some info
    strcpy(TmpStr, "\0");
    strcat(TmpStr, (getAtResult("Operator: ", "AT+COPS?", '"', '"')));
    strcat(TmpStr, (getAtResult("\nSignal: ", "AT+CSQ", ':', ',')));
    strcat(TmpStr, (getAtResult("\nIMEI: ", "AT+GSN", '\n', 'O')));
    sms.SendSMS(phone_number,TmpStr);    
  }
  else if(NULL != strstr(TmpStr,"PHONE PAGE-"))
  {// Request a page from phone book
    char * PageC = strrchr(TmpStr, '-');
    char Page = atoi(PageC+1);
    int P = (int)Page;
    if(P>=0 && P<=7)
    {
      ReadPhoneBook(P);
      sms.SendSMS(phone_number,TmpStr); 
    }   
  }
  else if(NULL != strstr(TmpStr,"PHONE READ-"))
  {// Request a single address from phone book
    char * AddrC = strrchr(TmpStr, '-');
    int Addr = atoi(AddrC+1);
    int A = (int)Addr;
    if(A>=0 && A<=63)
    {
      ReadNunmber(A, PhoneRecord);
      sms.SendSMS(phone_number, PhoneRecord); 
    }   
  }
  else if(NULL != strstr(TmpStr,"PHONE WRITE-"))
  {// Write a single address to phone book
    char * AddrC = strrchr(TmpStr, '-');
    char * PhoneToWrite = strrchr(TmpStr, ':');
    int Addr = atoi(AddrC+1);
    int A = (int)Addr;

    if(A>=0 && A<=63) // check boundaries
    {
      WriteNunmber(A, PhoneToWrite+1); // Write to EEPROM
      ReadNunmber(A, PhoneRecord); // Verify reading back the EEPROM
      sms.SendSMS(phone_number, PhoneRecord);  
    }   
  }
  else if(NULL != strstr(TmpStr,"PHONE FORMAT-1234"))
  {// Phone book format 
      FormatEeprom();
      sms.SendSMS(phone_number, "Phone Book Cleared"); // feedback anyway 
  }
  else
  {// If none of the above
    return false;
  }
  return true;
 }

 boolean UserCmd(void)
 {// user actions
  if(!strcmp(TmpStr,"ON 1"))
  {// OUT 1 = ON
      digitalWrite(Out1,HIGH);
      if(AckOn)
      {// confirm the action with a call back to the calling number if enabled
        Serial.println("Call Back Ack to: ");
        PrivacyPrint();
        call.Call(phone_number);
      }
  }
  else if(!strcmp(TmpStr,"OFF 1"))
  {// OUT 1 = OFF
      digitalWrite(Out1,LOW);
      if(AckOn)
      {
        Serial.println("Call Back Ack to: ");
        PrivacyPrint();
        call.Call(phone_number);
      }
  }
  else if(!strcmp(TmpStr,"ON 2"))
  {// OUT 2 = ON
      digitalWrite(Out2,HIGH);
      if(AckOn)
      {
        Serial.println("Call Back Ack to: ");
        PrivacyPrint();
        call.Call(phone_number);
      }
  }
  else if(!strcmp(TmpStr,"OFF 2"))
  {// OUT 2 = OFF
      digitalWrite(Out2, LOW);
      if(AckOn)
      {
        Serial.println("Call Back ACK to: ");
        PrivacyPrint();
        call.Call(phone_number);
      }
  }
  else if(!strcmp(TmpStr,"STATUS"))
  {// Request current status of the outputs without any change
    char A[2];
    strcpy(TmpStr,"Out 1=");
    itoa(digitalRead(Out1),A,2);
    strncat(TmpStr,A,2);
    strncat(TmpStr,"  Out 2=",8);
    itoa(digitalRead(Out2),A,2);
    strncat(TmpStr,A,2);
    sms.SendSMS(phone_number,TmpStr);    
  }
  else
  {// If none of the above
    return false;
  }
  return true;
 }

void PrivacyPrint(void)
{// if Privacy == OFF print the whole calling phone number
  char PriPhone[20];
  strcpy(PriPhone,phone_number);
  if(Privacy)
  {// mask out the phone number on printout to allow privacy
    memset(PriPhone,'*', 9);
  }
  Serial.print(PriPhone);
}
          
char * getAtResult(char * DescString, char * AtString, char StartChar, char StopChar)
{//get the value of the AT result cleaning out of character terminators
       char * pchS;
       char * pchE;
       char gsmRead[30];
       strcat(TmpStr,DescString);
       gsm.SimpleWriteln(AtString);
       delay(1000);
       gsm.read(gsmRead, 30);   
       pchS = strchr (gsmRead,StartChar);
       pchE = strrchr (gsmRead,StopChar);
       *pchE = '\0';
       return(pchS +1);
}

void ToUpperTmpStr(void)
{// command string can be both upper or lower case
  int i=0;
  while (TmpStr[i])
  {
    TmpStr[i]=toupper(TmpStr[i]);
    i++;
  }
}

